import type { Cache } from './utils';
declare type InternalCopier = <Value = any>(value: Value, cache: Cache) => Value;
export declare function copyArrayLoose(array: any[], prototype: any, copier: InternalCopier, cache: Cache): any;
declare function copyObjectLooseModern<Value extends {}>(object: Value, prototype: any, copier: InternalCopier, cache: Cache): Value;
/**
 * Get a copy of the object based on loose rules, meaning all enumerable keys
 * and symbols are copied, but property descriptors are not considered.
 */
export declare const copyObjectLoose: typeof copyObjectLooseModern;
/**
 * Get a copy of the object based on strict rules, meaning all keys and symbols
 * are copied based on the original property descriptors.
 */
export declare function copyObjectStrict<Value extends {}>(object: Value, prototype: any, copier: InternalCopier, cache: Cache): Value;
export declare function copyMap<Value extends Map<any, any>>(value: Value, Constructor: MapConstructor, copier: InternalCopier, cache: Cache): Value;
export declare function copyRegExp<Value extends RegExp>(value: Value, Constructor: RegExpConstructor): Value;
export declare function copySet<Value extends Set<any>>(value: Value, Constructor: SetConstructor, copier: InternalCopier, cache: Cache): Value;
export declare function createCopier(isStrict: boolean): (value: any, cache: Cache) => any;
export {};
